pro thm_sst_to_tplot,probes=probes

if not keyword_set(probes) then probes=['a','b','c','d','e']

for p=0,n_elements(probes)-1 do begin
    prb = probes[p]
    thx = 'th'+prb
    data_cache,thx+'_sst_raw_data',data,/get
    if not keyword_set(data) then continue
    dprint,thx

    nan=0
    name = thx+'_psif'
    time = *data.sif_064_time
    y = total(thm_part_decomp16(*data.sif_064_data,nan=nan),2)
    store_data,name+'_ang',data={x:time , y:y ,  v:findgen(64) }, dlimit={spec:1,zlog:1 ,no_interp:1, zrange:[1,2e4], ystyle:1}
    y = total(thm_part_decomp16(*data.sif_064_data,nan=nan),3)
    store_data,name+'_en',data={x:time , y:y ,  v:findgen(16) }, dlimit={spec:1,zlog:1 ,no_interp:1, zrange:[1,1e5], ystyle:1}
    y = total(y[*,0:11],2)
    store_data,name+'_tot',data={x:time , y:y  }, dlimit={ylog:1 , yrange:[1,1e6], ystyle:1}
    dprint,name

    name = thx+'_psef'
    time = *data.sef_064_time
    y = total(thm_part_decomp16(*data.sef_064_data,nan=nan),2)
    store_data,name+'_ang',data={x:time , y:y ,  v:findgen(64) }, dlimit={spec:1,zlog:1 ,no_interp:1, zrange:[1,2e4], ystyle:1}
    y = total(thm_part_decomp16(*data.sef_064_data,nan=nan),3)
    store_data,name+'_en',data={x:time , y:y ,  v:findgen(16) }, dlimit={spec:1,zlog:1 ,no_interp:1, zrange:[1,1e5], ystyle:1}
    Y = total(y[*,0:11],2)
    store_data,name+'_tot',data={x:time , y:y }, dlimit={ylog:1 , yrange:[1,1e6], ystyle:1}
    dprint,name

    name = thx+'_psir'
    time = *data.sir_001_time
    y = thm_part_decomp16(*data.sir_001_data,nan=nan)
    store_data,name+'_en',data={x:time , y:y ,  v:findgen(16) }, dlimit={spec:1,zlog:1 ,no_interp:1, zrange:[1,1e5]}
    y = total(y[*,0:11],2)
    store_data,name+'_tot',data={x:time , y:y }, dlimit={ylog:1 , yrange:[1,1e6], ystyle:1}
    dprint,name

    name = thx+'_pser'
    time = *data.ser_001_time
    y = thm_part_decomp16(*data.ser_001_data,nan=nan)
    store_data,name+'_en',data={x:time , y:y ,  v:findgen(16) }, dlimit={spec:1,zlog:1 ,no_interp:1, zrange:[1,1e5]}
    y = total(y[*,0:11],2)
    store_data,name+'_tot',data={x:time , y:y }, dlimit={ylog:1 , yrange:[1,1e6], ystyle:1}
    dprint,name


endfor


end
