pro spinmodel_addseg,mptr,newseg

sp = (*mptr).segs_ptr

if ((*mptr).lastseg EQ -1) then begin
  (*sp)[0] = newseg
  (*mptr).lastseg = 0L
endif else begin
   lseg=(*sp)[(*mptr).lastseg]
   if (newseg.t1 EQ lseg.t2) then begin
      ;
      ; Normal case: segments are contiguous
      ;
      (*mptr).lastseg = (*mptr).lastseg + 1
      newseg.c1 = lseg.c2
      newseg.c2 = lseg.c2 + newseg.c2
      (*sp)[(*mptr).lastseg] = newseg
   endif else begin
      ;print,'seam detected'
      ;print,lseg
      spinper = 360.0D/lseg.b
      gap_spin_count = (newseg.t1 - lseg.t2)/spinper
      gap_time = newseg.t1 - lseg.t2
      if (gap_spin_count GT 0.5) then begin
         ; Gap of 1 or more spins between segments, add fill
         ;print,'1+ spin gap, adding fill segment'
         gap_nspins = floor(gap_spin_count + 0.5)
         gap_spinper = (newseg.t1 - lseg.t2)/(1.0D * gap_nspins)
         fillseg = {spinmodel_segment,t1:lseg.t2, t2:newseg.t1, c1:lseg.c2,$
              c2:lseg.c2+gap_nspins,b:360.0D/gap_spinper,c:0.0D,npts:0L,$
               maxgap:gap_time, phaserr:0.0D}
         (*mptr).lastseg = (*mptr).lastseg+1
         (*sp)[(*mptr).lastseg] = fillseg
         ;print,fillseg
         newseg.c1 = fillseg.c2
         newseg.c2 = newseg.c1 + newseg.c2
         (*mptr).lastseg = (*mptr).lastseg + 1
         (*sp)[(*mptr).lastseg] = newseg
         ;print,newseg
      endif else if (gap_spin_count GT -0.5) then begin
         if ((lseg.c2 - lseg.c1) GT 2) then begin
            ;print,'<1 spin gap, stealing spin from last segment'
            c2_new = lseg.c2 - 1

            segment_interp_n,lseg,c2_new,t_last,dummy

            lseg.c2 = c2_new
            lseg.t2 = t_last
            (*sp)[(*mptr).lastseg].c2 = c2_new
            (*sp)[(*mptr).lastseg].t2 = t_last
            ;print,lseg
            dt = newseg.t1-t_last
            spinper = dt
            fillseg = {spinmodel_segment,t1:t_last,t2:newseg.t1,c1:c2_new,$
                 c2:c2_new+1,b:360.0D/spinper,c:0.0D,npts:0L,maxgap:dt,$
                 phaserr:0.0D}
            (*mptr).lastseg = (*mptr).lastseg + 1
            ;print,fillseg
            (*sp)[(*mptr).lastseg] = fillseg
            newseg.c1 = fillseg.c2
            newseg.c2 = newseg.c2 + newseg.c1 
            (*mptr).lastseg = (*mptr).lastseg + 1
            (*sp)[(*mptr).lastseg] = newseg
         endif else if (newseg.c2 GT 2) then begin
            ;print,'<1 spin gap, stealing spin from next segment'

            segment_interp_n,newseg,1,t_last,dummy

            dt = t_last - newseg.t1
            bp = newseg.b + 2.0D*newseg.c*dt
            newseg.b = bp
            newseg.t1 = newseg.t1 + dt
            newseg.c1 = lseg.c2 + 1
            newseg.c2 = newseg.c2 + newseg.c1
            fill_spinper = newseg.t1 - lseg.t2
            gap_time = fill_spinper
            fillseg = {spinmodel_segment,t1:lseg.t2,t2:newseg.t1,c1:lseg.c2,$
                c2:lseg.c2 + 1,b:360.0D/fill_spinper,c:0.0D, npts: 0L,$
                 maxgap: gap_time,phaserr:0.0D}
            (*mptr).lastseg = (*mptr).lastseg + 1
            (*sp)[(*mptr).lastseg] = fillseg
            (*mptr).lastseg = (*mptr).lastseg + 1
            (*sp)[(*mptr).lastseg] = newseg
         endif else begin
            message,'<1 spin gap, but neither segment has enough spins to steal.  This should not happen!'
         endelse
      endif else begin
         message,'Unexpected time sequence...this should not happen!'
         stop
      endelse
   endelse
endelse
end
